Subject: bug#16901: 24.3.50; emacs_backtrace.txt

From: Eli Zaretskii <[email-masked]>
Date: Thu, 20 Mar 2014 20:31:37 +0200

> Date: Fri, 28 Feb 2014 19:44:46 +0400
> From: Dmitry Antipov <[email-masked]>
> Cc: [email-masked], [email-masked],
>  Emacs development discussions <[email-masked]>
> 
> Now I have two crash reports to make me worry about GC. Both are
> irregular and looks hard to reproduce:
> 
>   - this bug (crash in compact_small_strings, MS-Windows only (?))
> 
>   - http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16817#11 - crash
>     marking C stack, OSX-only (?)
> 
> These crashes may be originated by the same bug (probably irregular
> heap corruption). It's known that GC-related crashes may be caused
> by freeing fonts during gc_sweep; this is
> http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16069, but it should
> not affect MS-Windows and OSX (and hopefully I'll fix it soon).
> 
> On GNU/Linux, valgrind makes great job in finding memory-related
> errors; if there are similar tools for other platforms, it would
> be nice to try.

I've run Emacs on Windows under Dr. Memory (http://www.drmemory.org/),
but saw nothing appropriate.  However, there's no reproducer, so it's
hard to know if I did what was needed.  Perhaps you could come up with
a function to execute compact_small_strings, then I'd run that and see
what I get.